// JoystickDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "JoystickDemo.h"
#include "JoystickDemoDlg.h"
#include "DIJoystick.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CDIJoystick myJoystick1;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJoystickDemoDlg dialog

CJoystickDemoDlg::CJoystickDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CJoystickDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJoystickDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	m_Down = FALSE;
	m_Fire = FALSE;
	m_Left = FALSE;
	m_Right = FALSE;
	m_Up = FALSE;
	m_XAxis = _T("");
	m_YAxis = _T("");
	m_ZAxis = _T("");
	m_FireText = _T("");
	m_RXAxis = _T("");
	m_RYAxis = _T("");
	m_RZAxis = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CJoystickDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJoystickDemoDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
		DDX_Control(pDX, IDC_BUTTON_NAMES, m_ctlButtonNames);
	DDX_Control(pDX, IDC_JOYSTICK_NAME, m_ctlJoystickName);
	DDX_Check(pDX, IDC_DOWN, m_Down);
	DDX_Check(pDX, IDC_FIRE, m_Fire);
	DDX_Check(pDX, IDC_LEFT, m_Left);
	DDX_Check(pDX, IDC_RIGHT, m_Right);
	DDX_Check(pDX, IDC_UP, m_Up);
	DDX_Text(pDX, IDC_XAXIS, m_XAxis);
	DDX_Text(pDX, IDC_YAXIS, m_YAxis);
	DDX_Text(pDX, IDC_ZAXIS, m_ZAxis);
	DDX_Text(pDX, IDC_FIRETEXT, m_FireText);
	DDX_Text(pDX, IDC_RXAXIS, m_RXAxis);
	DDX_Text(pDX, IDC_RYAXIS, m_RYAxis);
	DDX_Text(pDX, IDC_RZAXIS, m_RZAxis);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CJoystickDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CJoystickDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_BUTTON_NAMES, OnSelchangeButtonNames)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_JOYSTICK_NAME, OnSelchangeJoystickName)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJoystickDemoDlg message handlers

BOOL CJoystickDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	//////////////////////////////////////////////////////////////////////
	//
	// Set the HWND for this Dialog Instance To Enable DInput!
	//
	//////////////////////////////////////////////////////////////////////

	CWnd *jb=this;

	myJoystick1.SetHWND(jb->m_hWnd);

	// Reset Combo Control
	m_ctlJoystickName.ResetContent();

	LPCDIDEVICEINSTANCE lpddi=NULL;

	// Ensure you have First Joystick ID to start search for additional Devices!
	lpddi=myJoystick1.GetFirstJoystickID();

	if(!lpddi)
	{
		// No joysticks have been found!
		MessageBox("I have not been able to find a joystick on your system.","No Joystick Detected",MB_ICONHAND|MB_OK);
		OnCancel();
	}
	else
	{

		while(lpddi)
		{
			int x=m_ctlJoystickName.AddString(lpddi->tszInstanceName);
			m_ctlJoystickName.SetItemDataPtr(x,(void*)lpddi);
			lpddi=myJoystick1.GetNextJoystickID();
		}

		m_ctlJoystickName.SetCurSel(0);
		OnSelchangeButtonNames();

		SetTimer(1,50,NULL);
		
		return TRUE;  // return TRUE unless you set the focus to a control
					  // EXCEPTION: OCX Property Pages should return FALSE
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CJoystickDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CJoystickDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CJoystickDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CJoystickDemoDlg::OnSelchangeButtonNames() 
{
	// TODO: Add your control notification handler code here

	CWnd*jb=this;
	myJoystick1.SetHWND(jb->m_hWnd);

	LPCDIDEVICEINSTANCE lpddi=NULL;
	
	m_ctlButtonNames.ResetContent();
	
	int x=m_ctlJoystickName.GetCurSel();
	
	lpddi=(LPCDIDEVICEINSTANCE)m_ctlJoystickName.GetItemDataPtr(x);

	GUID myguid;

	if(lpddi && ((int)lpddi!=-1))
	{

		memcpy(&myguid,&(lpddi->guidInstance),sizeof(GUID));
		
		//bool flag=myJoystick1.CreateDevice(&myguid);
		myJoystick1.SetPreferredDevice(&myguid);

		m_Buttons=myJoystick1.HowManyButtons();

		TCHAR* name=NULL;
		name=myJoystick1.GetFirstButtonName();

		while(name)
		{
			m_ctlButtonNames.AddString(name);
			name=myJoystick1.GetNextButtonName();
		}
	}

	m_ctlButtonNames.SetCurSel(0);	
}

void CJoystickDemoDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	KillTimer(1);
	CDialog::OnCancel();
}

void CJoystickDemoDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	myJoystick1.PollDevice();

	if(myJoystick1.IsJoystickLeft()) m_Left=true; else m_Left=false;
	if(myJoystick1.IsJoystickRight()) m_Right=true; else m_Right=false;
	if(myJoystick1.IsJoystickUp()) m_Up=true; else m_Up=false;
	if(myJoystick1.IsJoystickDown()) m_Down=true; else m_Down=false;
	if(myJoystick1.IsJoystickFire()) m_Fire=true; else m_Fire=false;

	LPDIJOYSTATE2 joy=myJoystick1.GetJoystickStateInfo();

	m_XAxis.Format("%d",joy->lX);
	m_YAxis.Format("%d",joy->lY);
	m_ZAxis.Format("%d",joy->lZ);

	m_RXAxis.Format("%d",joy->lRx);
	m_RYAxis.Format("%d",joy->lRy);
	m_RZAxis.Format("%d",joy->lRz);


	m_FireText.Empty();

	for(int i=0;i<m_Buttons;i++)
	{
		if(myJoystick1.IsJoystickFire(i))
		{
			CString temp;
			temp.Format("Fire Button : %d\r\n",i);
			m_FireText+=temp;
		}
	}

	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}

void CJoystickDemoDlg::OnButton1() 
{
	myJoystick1.RunControlPanel();	
}


void CJoystickDemoDlg::OnSelchangeJoystickName() 
{
	OnSelchangeButtonNames();
	
}
